%
% Programmieraufgaben Blatt 10
%

I1    = double(imread('fg001.pgm'));
I2    = double(imread('fg002.pgm'));
[m n] = size(I1);

Ix = I1(:, [2:end end])-I1(:, [1 1:end-1]);
Ix(:, 2:end-1) = Ix(:,2:end-1)/2;
Iy = I1([2:end end], :)-I1([1 1:end-1], :); 
Iy(2:end-1, :) = Iy(2:end-1, :)/2;
It = I2-I1;

mask = fspecial('gaussian', 16, 2);
Ixx  = imfilter(Ix.*Ix,  mask);
Ixy  = imfilter(Ix.*Iy,  mask);
Iyy  = imfilter(Iy.*Iy,  mask);
b1   = imfilter(-It.*Ix, mask);
b2   = imfilter(-It.*Iy, mask);

det = Ixx.*Iyy - Ixy.^2;
V1  = ones([m n])./det.*( Iyy.*b1-Ixy.*b2);
V2  = ones([m n])./det.*(-Ixy.*b1+Ixx.*b2);

flow(:,:,1) = V1;
flow(:,:,2) = V2;
color = flowToColor(flow,3);
imshow(color)
